<template>
  <div>
    <h1 class="title">Fetch des données (API) - Examples</h1>

    <button @click="addPost">Ajouter un article</button>
    <div class="posts">
      <div v-for="post in posts" :key="post.id" class="posts-item">
        <span class="posts-item-author">Utilisateur {{ post.userId }}</span>
        <h3 class="posts-item-title">{{ post.title }}</h3>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  name: 'Axios',

  data: function () {
    return {
      posts: []
    }
  },

  // created () {
  //   axios.get(`https://jsonplaceholder.typicode.com/posts`)
  //   .then(response => {
  //     this.posts = response.data
  //   })
  //   .catch(e => {
  //     console.log(e);
  //   })
  // }

  methods: {
    async addPost () {
      try {
        const response = await axios.post(`https://jsonplaceholder.typicode.com/posts`, {
          "userId": 1,
          "title": "Super toto",
          "body": "quia et suscipit\nsuscipit recusandae consequuntur expedita et cum\nreprehenderit molestiae ut ut quas totam\nnostrum rerum est autem sunt rem eveniet architecto"
        });

        this.posts.push(response.data);
      } catch (e) {
      console.log(e);
      }
    }
  },

  async created () {
    try {
      const response = await axios.get(`http://jsonplaceholder.typicode.com/posts`)
      this.posts = response.data;
    } catch (e) {
     console.log(e);
    }
  }
}
</script>

<style lang="scss" scoped>
  .title {
    text-align: center;
  }

  .posts {
    display: flex;
    justify-content: center;
    flex-wrap: wrap;
    background-image: radial-gradient(#22D2A0 30%, #FFFFFF 30%);
    background-size: 2px 3px;

    &-item {
      width: 300px;
      height: 90px;
      background-color: white;
      border: 3px solid #555BFF;
      padding: 15px;
      margin: 15px;
      color: #555BFF;
      transition-duration: 1s;

      &:hover {
        transform: scale(1.1);
        cursor: pointer;
      }

      &-author {
        font-size: 11px;
        text-transform: uppercase;
        letter-spacing: 0.5px;
        margin-bottom: 10px;
      }

      &-title {
        font-size: 16px;
        font-weight: bold;
      }
    }
  }
</style>
